/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "operator/operator.pmh"

namespace fe
{

void SurfaceCurveOp::initialize(void)
{
	catalog<String>("icon")="FE_alpha";

	catalog<I32>("Segments")=4;
	catalog<I32>("Segments","low")=1;
	catalog<I32>("Segments","high")=8;
	catalog<I32>("Segments","min")=1;
	catalog<I32>("Segments","max")=100;

	catalog<Real>("Length")=1.0;
	catalog<Real>("Length","low")=0.0;
	catalog<Real>("Length","high")=10.0;
	catalog<Real>("Length","min")=0.0;
	catalog<Real>("Length","max")=100.0;
}

void SurfaceCurveOp::handle(Record& a_rSignal)
{
	sp<DrawI> spDrawI;
	if(!accessDraw(spDrawI,a_rSignal)) return;

	const I32 segments=catalog<I32>("Segments");
	const Real length=catalog<Real>("Length");
	const Real scale=length/(Real)segments;

	SpatialVector pointArray[segments+1];
	for(I32 index=0;index<=segments;index++)
	{
		set(pointArray[index],0.001*index*index,index*scale);
	}

	spDrawI->drawLines(pointArray,NULL,segments+1,DrawI::e_strip,false,NULL);
}

} // namespace
